from py2neo import Graph, Node, Relationship, NodeMatcher, RelationshipMatcher

# 连接neo4J的相关配置信息
neo4j_url = "http://localhost:7474"
user = "neo4j"
pwd = "4399"


# 对人物关系进行转变
def rel_trans(relation):
    result = "none"
    if (relation == "老婆" or
            relation == "妻子" or
            relation == "配偶" or
            relation == "媳妇" or
            relation == "内人"):
        result = "配偶"
    elif (relation == "兄弟" or
          relation == "哥哥" or
          relation == "弟弟" or
          relation == "结义兄弟"):
        result = "兄弟"
    elif (relation == "父亲" or
          relation == "老爸" or
          relation == "爸爸" or
          relation == "Daddy"):
        result = "父亲"
    elif (relation == "母亲" or
          relation == "老妈" or
          relation == "妈妈" or
          relation == "Mommy"):
        result = "母亲"
    return result


# 查询人物关系的问答
def find_person(question, graph):
    list1 = question.split("的")
    name = list1[0]
    list2 = list1[1].split("是")
    relation = list2[0]
    cur_rel = rel_trans(relation)
    if cur_rel == "none":
        print("没有看懂您说的什么意思哦~")
        return 0
    else:
        print("为您找到以下答案：")
        print(name + "的" + relation + "为：")
        # 查找关系
        node_matcher = NodeMatcher(graph)
        relationship_matcher = RelationshipMatcher(graph)
        node = node_matcher.match("Person").where(name=name).first()
        relationship = list(relationship_matcher.match([node], r_type=cur_rel))
        if relationship == "none":
            print("抱歉，这件事我也不知道~")
        else:
            for i in relationship:
                print(i.end_node["name"])


def find_work(question, graph):
    list1 = question.split("是")
    name = list1[0]
    if name == "none":
        print("没有看懂您说的什么意思哦~")
        return 0
    else:
        print("为您找到以下答案：")
        node_matcher = NodeMatcher(graph)
        relationship_matcher = RelationshipMatcher(graph)
        node = node_matcher.match("Person").where(name=name).first()

        print(name + "曾经效力为：")
        relationship = list(relationship_matcher.match([node], r_type="曾效力"))
        for i in relationship:
            print(i.end_node["name"])

        print(name + "主要效力为：")
        relationship = list(relationship_matcher.match([node], r_type="主效"))
        for i in relationship:
            print(i.end_node["name"])


def main():
    # 链接库
    graph = Graph(neo4j_url, auth=(user, pwd))

    print("欢迎使用三国演义问答系统！")
    print("-----------------------------------------------")
    flag = 1  # 标志退出位
    while flag:
        question = input("请输入您的问题：(输入0退出系统)")
        if len(question) == 0:  # 没有输入问题继续询问
            continue
        try:
            # 尝试将输入转换为整型数据
            choose = int(question)
        except:
            # 如果不能转化为整型数据，证明问的是问题，进行问答操作

            # 查看是否是询问人物关系问题
            list1 = question.split("的")
            name = list1[0]
            if name != "none" and len(name) < 5:  # 证明分割出来的是一个人名
                # 进行查询人物关系的问答程序
                find_person(question, graph)
            else:
                #  则默认为查看国家问题，进行国家问题的问答程序
                find_work(question, graph)
        else:
            # 输入的是数字
            if choose == 0:
                flag = 0
            else:
                print("请输入规范的数字哦~")
        print("-----------------------------------------------")

    print("期待您的再次使用！")


if __name__ == '__main__':
    main()
    """
    输入输出有一定的模板，比如询问人物关系：
    XX的XX是？
    刘备的老婆是？曹操的妻子是？孙权的父亲是？
    之类的问题
    询问国家的模板是：
    XX是XXXXX？
    比如：赵云是哪个国家的？
    会有答非所问以及一问三不知的情况发生!!>-<!!
    """
